﻿<AML>
 <Item type="Method" id="6FC30D709B40437A804D6562689E71FE" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			sop_ci_ispost
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                -If transaction is already "Post To GL",can't update.

            Hooks:
                Type:		ItemType : sop_commercial_invoice
                Event:		Server Events ( onAfterLock )
                
            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "sop_ci_ispost";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var _id = this.getID();
                
                Item _ispost = myInnovator.newItem("sop_commercial_invoice", "get");

                _ispost.setProperty("id", _id);
                _ispost.setPropertyCondition("id", "eq");
                _ispost.setProperty("pop_invoice_status", "Approved");
                _ispost.setPropertyCondition("pop_invoice_status", "ne");
                var logicalAnd = _ispost.newAND();
                logicalAnd.setProperty("pop_invoice_status", "Created");
                logicalAnd.setPropertyCondition("pop_invoice_status", "ne");
                var logicalAnd1 = _ispost.newAND();
                logicalAnd1.setProperty("pop_invoice_status", "Review");
                logicalAnd1.setPropertyCondition("pop_invoice_status", "ne");
                var l_result = _ispost.apply();
                var l_count = l_result.getItemCount();               
                if (l_count > 0)
                {
                    l_result.unlockItem();
                    return myInnovator.newError("Can't update posted item!");                  
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }]]></method_code>
  <method_type>C#</method_type>
  <name>sop_ci_ispost</name>
 </Item>
</AML>